/**
    Copyright (C) 2002, 2003  Michael Ahlberg, Mns Rullgrd

    Licensed under the Open Software License version 2.0
**/

#ifndef _TCALLOC_H
#define _TCALLOC_H

#include <tctypes.h>

typedef void (*tc_ref_fn)(void *);
typedef void *(*tcattr_ref_t)(void *);

typedef struct tcattr {
    char *name;
    void *value;
} tcattr_t;

extern void *tcalloc(size_t);
extern void *tcallocd(size_t, tc_ref_fn, tcfree_fn);
extern void *tcallocz(size_t);
extern void *tcallocdz(size_t, tc_ref_fn, tcfree_fn);
extern void *tcref(void *);
extern void tcfree(void *);

extern int tcattr_set(void *p, char *name, void *val,
		      tcattr_ref_t r, tcfree_fn f);
extern void *tcattr_get(void *p, char *name);
extern int tcattr_getall(void *ptr, int n, tcattr_t *attr);
extern int tcattr_del(void *p, char *name);

#endif
