/**
    Copyright (C) 2001, 2002, 2003  Michael Ahlberg, Mns Rullgrd

    Licensed under the Open Software License version 2.0
**/

#ifndef _TCCONF_H
#define _TCCONF_H

#include <stdio.h>
#include <tctypes.h>

typedef struct tcconf_section tcconf_section_t;

extern tcconf_section_t *tcconf_load(tcconf_section_t *, void *, tcio_fn);
extern tcconf_section_t *tcconf_load_file(tcconf_section_t *, char *file);
extern tcconf_section_t *tcconf_load_string(tcconf_section_t *sec,
					    const char *conf, int size);
extern int tcconf_write(tcconf_section_t *tcc, void *file, tcio_fn);
extern tcconf_section_t *tcconf_getsection(tcconf_section_t *sec, char *name);
extern int tcconf_getvalue(tcconf_section_t *sec, char *name, char *fmt, ...);
extern int tcconf_setvalue(tcconf_section_t *sec, char *name, char *fmt, ...);
extern tcconf_section_t *tcconf_new(char *name);
extern int tcconf_clearvalue(tcconf_section_t *sec, char *name);
extern int tcconf_nextvalue(tcconf_section_t *sec, char *name, void **state,
			    char *fmt, ...);
extern tcconf_section_t *tcconf_nextsection(tcconf_section_t *sec, char *name,
					    void **state);
extern tcconf_section_t *tcconf_merge(tcconf_section_t *dst,
				      tcconf_section_t *src);

#endif
