/**
    Copyright (C) 2002  Michael Ahlberg, Mns Rullgrd

    Licensed under the Open Software License version 2.0
**/

#ifndef _TCTREE_H
#define _TCTREE_H

#include <tc.h>
#include <tctypes.h>

typedef struct tctree tctree_t;

extern tctree_t *tctree_new(int locking, u_int32_t flags);

extern int tctree_find(tctree_t *t, void *key, void *ret, tccompare_fn cmp);

extern int tctree_search(tctree_t *t, void *key, void *ret, tccompare_fn cmp);

extern int tctree_replace(tctree_t *t, void *key, tccompare_fn cmp);

extern int tctree_delete(tctree_t *t, void *key, void *ret, tccompare_fn cmp);

extern int tctree_destroy(tctree_t *t, tcfree_fn f);

#endif
