/**
    Copyright (C) 2003  Michael Ahlberg, Mns Rullgrd

    Licensed under the Open Software License version 2.0
**/

#include <stdio.h>
#include <stdlib.h>
#include <tctypes.h>
#include <tcstring.h>
#include <tcalloc.h>
#include <tcconf.h>
#include <unistd.h>

extern int
main(int argc, char **argv)
{
    tcconf_section_t *s = NULL;
    FILE *out = stdout;
    char *outfile = "-";
    int opt;
    int i;

    while((opt = getopt(argc, argv, "o:h")) != -1){
	switch(opt){
	case 'o':
	    outfile = optarg;
	    break;
	case 'h':
	    fprintf(stderr, "Usage: tcconfdump [-o file] [file ...]\n");
	}
    }

    if(strcmp(outfile, "-")){
	if(!(out = fopen(outfile, "w"))){
	    perror(outfile);
	    exit(1);
	}
    }

    argc -= optind;
    argv += optind;

    for(i = 0; i < argc; i++){
	tcconf_section_t *n;
	if(strcmp(argv[i], "-")){
	    n = tcconf_load_file(s, argv[i]);
	} else {
	    n = tcconf_load(s, stdin, (tcio_fn) fread);
	}
	if(n)
	    s = n;
	else
	    fprintf(stderr, "tcconfdump: error loading %s\n", argv[i]);
    }

    if(!argc)
	s = tcconf_load(s, stdin, (tcio_fn) fread);

    if(s)
	tcconf_write(s, out, (tcio_fn) fwrite);

    fclose(out);

    return 0;
}
