/**
    Copyright (C) 2003  Michael Ahlberg, Mns Rullgrd

    Licensed under the Open Software License version 2.0
**/

#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <sys/stat.h>

extern int
tcmkpath(char *path, int mode)
{
    char *p = strdup(path);
    char *e = strrchr(p, '/');
    struct stat st;
    int ret = -1;

    if(e > p){
	*e = 0;
	if(tcmkpath(p, mode))
	    goto end;
    }

    if(stat(path, &st)){
	if(errno != ENOENT)
	    goto end;
	if(mkdir(path, mode))
	    goto end;
    } else if(!S_ISDIR(st.st_mode)){
	goto end;
    }

    ret = 0;
end:
    free(p);
    return ret;
}
