/**
    Copyright (C) 2001  Michael Ahlberg, Mns Rullgrd

    Licensed under the Open Software License version 2.0
**/

#define _XOPEN_SOURCE 1
#define _XOPEN_SOURCE_EXTENDED 1

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <tctypes.h>
#include <tctime.h>


static char *timefmts[13] = {
    "%Y-%m-%d %H:%M:%S",
    "%y-%m-%d %H:%M:%S",
    "%y%m%d %H:%M:%S",
    "%Y%m%d %H:%M:%S",
    "%y%m%d %H:%M",
    "%Y%m%d %H:%M",
    "%b %d %Y %H:%M:%S",
    "%b %d %Y %H:%M",
    "%d %b %Y %H:%M:%S"
    "%d %b %Y %H:%M",
    "%H:%M:%S",
    "%H:%M",
    NULL
};


extern char *
strtotime(char *ts, struct tm *tm, char **fmts)
{
    char *t;
    time_t lt;
    int i;

    if(fmts == NULL)
	fmts = timefmts;

    for(i = 0;
	fmts[i] != NULL &&
	    ((t = strptime(ts, fmts[i], tm)) == NULL || *t != 0);
	i++);

    if(fmts[i] != NULL){
	lt = time(NULL);
	localtime_r(&lt, tm);
	strptime(ts, fmts[i], tm);
    }

    return fmts[i];
}
