/**
    Copyright (C) 2001  Michael Ahlberg, Mns Rullgrd

    Licensed under the Open Software License version 2.0
**/

#ifndef _TCC_INTERNAL_H
#define _TCC_INTERNAL_H

#include <tctypes.h>
#include <tclist.h>

#define TCC_INTEGER  1
#define TCC_FLOAT    2
#define TCC_BOOLEAN  3
#define TCC_STRING   4
#define TCC_REF      5
#define TCC_IGNORE   (1<<28)
#define TCC_EXPAND   (1<<29)
#define TCC_LONG     (1<<30)
#define TCC_UNSIGNED (1U<<31)
#define TCC_TYPEMASK (TCC_IGNORE-1)

typedef struct {
    int type;
    union {
	uint64_t integer;
	double floating;
	int boolean;
	char *string;
    } value;
} tcc_value;

typedef struct _conf_section conf_section;
struct _conf_section {
    char *name;
    tclist_t *entries;
    tclist_t *merge;
    conf_section *parent;
};

struct tcconf_section {
    conf_section *sec;
    tcconf_section_t *parent;
};

#define TCC_VALUE    1
#define TCC_SECTION  2
#define TCC_MSECTION 3

typedef struct {
    int type;
    struct {
	char *key;
	tclist_t *values;
    } value;
    conf_section *section;
} tcc_entry;


extern conf_section *conf_new(char *name);
extern int tcc_addint(tcc_entry *, long long);
extern int tcc_addfloat(tcc_entry *, double);
extern int tcc_addstring(tcc_entry *, char *, int);
extern int tcc_addbool(tcc_entry *, int);
extern int tcc_addref(tcc_entry *te, char *ref);
extern conf_section *tcc_lex(void *, tcio_fn, conf_section *);
extern tcc_entry *create_entry(conf_section *sec, char *name, int type);

#endif
